# Specfem3D Globe

Program specfem3D from `SPECFEM3D_GLOBE` is a 3-D spectral-element solver for the Earth.
It uses a mesh generated by program meshfem3D.

Main "historical" authors: Dimitri Komatitsch and Jeroen Tromp
  (there are currently many more!)

## Installation

Instructions on how to install and use `SPECFEM3D_GLOBE` are available
in the 

- PDF manual located in directory: [doc/USER_MANUAL](doc/USER_MANUAL).

- HTML manual (latest version): [specfem3d-globe.readthedocs.io](http://specfem3d-globe.readthedocs.io/)


## Development

[![Build Status](https://travis-ci.org/geodynamics/specfem3d_globe.svg?branch=devel)](https://travis-ci.org/geodynamics/specfem3d_globe)
[![codecov](https://codecov.io/gh/geodynamics/specfem3d_globe/branch/devel/graph/badge.svg)](https://codecov.io/gh/geodynamics/specfem3d_globe)
[![Documentation Status](https://readthedocs.org/projects/specfem3d-globe/badge/?version=latest)](https://specfem3d-globe.readthedocs.io/en/latest/?badge=latest)
[![License: GPL v3](https://img.shields.io/badge/License-GPL%20v3-blue.svg)](LICENSE)


* Travis tests: [travis-ci specfem3d_globe](https://travis-ci.org/geodynamics/specfem3d_globe/builds)


* *Jenkins* Comparing ADIOS kernels: [![Build
  Status](https://jenkins.princeton.edu/buildStatus/icon?job=SPECFEM_ADIOS/adios_kernels)](https://jenkins.princeton.edu/job/SPECFEM_ADIOS/job/adios_kernels/)


Development is hosted on GitHub in the
[geodynamics/specfem3d_globe repository](https://github.com/geodynamics/specfem3d_globe).

Git submodules for data files and examples are hosted on the CIG servers
at:

  * [Data](http://vcs.geodynamics.org/gitweb/?p=specfem3d_globe_data.git)
  * [Examples](http://vcs.geodynamics.org/gitweb/?p=specfem3d_globe_examples.git)


## Computational Infrastructure for Geodynamics (CIG)

Seismology software repository: [SPECFEM3D_GLOBE](https://geodynamics.org/cig/software/specfem3d_globe/)

